void drawShape(int wbNum, int wbColor) { 

  for (int i = aListLength-1; i >= 0; i--) {
    locations.remove(i);
  }

  for (int i=1; i<rowCount; i++) {
    if (IdNum[i] == colId[wbNum]) {
      Location test = new Location(lats[i], longs[i]);
      locations.add(test);
    }
  }
  aListLength = locations.size();
  done = true;

  s = createShape();
  if (VisualizationType == 1) {
    s.beginShape();
  } else if (VisualizationType == 2) {
    s.beginShape(TRIANGLE_FAN);
  } else {
    s.beginShape(QUAD_STRIP);
  }

  for (int i=1; i<locations.size ()-1; i++) {

    ScreenPosition posLast = map1.getScreenPosition(locations.get(i-1));    
    ScreenPosition pos = map1.getScreenPosition(locations.get(i));
    ScreenPosition posNext = map1.getScreenPosition(locations.get(i+1));
    ScreenPosition lastPos = map1.getScreenPosition(locations.get(locations.size()-1));
    ScreenPosition firstPos = map1.getScreenPosition(locations.get(0));


    s.strokeWeight(LineSize);
    //s.fill(colors[0]);
    s.noFill();


    if (VisualizationType == 1) {
      s.noStroke();
      s.vertex(firstPos.x, firstPos.y, 0);
      //s.vertex(posLast.x, posLast.y, i);
//      if (StructureColor == 1) {
//        s.stroke(50, 50);
//        s.fill(50, 50);
//      } else if (StructureColor == 2) {
//        s.stroke(colors[wbColor], random(0, 120));
//        s.fill(colors[0], 30);
//      } else if (StructureColor == 3) {
//        s.stroke(210, 80);
//        s.stroke(210, 80);
//      }
      s.stroke(colors[wbColor], 70);
      s.vertex(firstPos.x, firstPos.y, 0);
      s.bezierVertex(firstPos.x, firstPos.y, 0, pos.x, pos.y, i+10, lastPos.x, lastPos.y, (locations.size()-1)+10);
    } else if (VisualizationType == 0 || VisualizationType == 2) {

      //for normal shape building
      // (not using this at the moment) s.vertex(posLast.x, posLast.y, i);

      if (StructureColor == 1) {
        s.stroke(50, 50);
        s.fill(50, 50);
      } else if (StructureColor == 2) {
        s.stroke(colors[wbColor], random(0, 120));
        s.fill(colors[0], 30);
      } else if (StructureColor == 3) {
        s.stroke(210, 80);
        s.stroke(210, 80);
      }

      s.vertex(pos.x, pos.y, i+10);
    }
  }
  s.endShape();
  shape(s);
}

